"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const types = require("../../../utils/types.js");
const index = require("../../../hooks/use-namespace/index.js");
const useFormCommonProps = require("../../form/src/hooks/use-form-common-props.js");
const text = require("./text.js");
const Vue = require("vue");
var text_vue_vue_type_script_setup_true_lang_default = /* @__PURE__ */ Vue.defineComponent({
  name: "ElText",
  __name: "text",
  props: text.textProps,
  setup(__props) {
    const props = __props;
    const textRef = Vue.ref();
    const textSize = useFormCommonProps.useFormSize();
    const ns = index.useNamespace("text");
    const textKls = Vue.computed(() => [
      ns.b(),
      ns.m(props.type),
      ns.m(textSize.value),
      ns.is("truncated", props.truncated),
      ns.is("line-clamp", !types.isUndefined(props.lineClamp))
    ]);
    const bindTitle = () => {
      var _a, _b, _c, _d, _e, _f, _g;
      if (Vue.useAttrs().title) return;
      let shouldAddTitle = false;
      const text2 = ((_a = textRef.value) == null ? void 0 : _a.textContent) || "";
      if (props.truncated) {
        const width = (_b = textRef.value) == null ? void 0 : _b.offsetWidth;
        const scrollWidth = (_c = textRef.value) == null ? void 0 : _c.scrollWidth;
        if (width && scrollWidth && scrollWidth > width) shouldAddTitle = true;
      } else if (!types.isUndefined(props.lineClamp)) {
        const height = (_d = textRef.value) == null ? void 0 : _d.offsetHeight;
        const scrollHeight = (_e = textRef.value) == null ? void 0 : _e.scrollHeight;
        if (height && scrollHeight && scrollHeight > height) shouldAddTitle = true;
      }
      if (shouldAddTitle) (_f = textRef.value) == null ? void 0 : _f.setAttribute("title", text2);
      else (_g = textRef.value) == null ? void 0 : _g.removeAttribute("title");
    };
    Vue.onMounted(bindTitle);
    Vue.onUpdated(bindTitle);
    return (_ctx, _cache) => {
      return Vue.openBlock(), Vue.createBlock(Vue.resolveDynamicComponent(__props.tag), {
        ref_key: "textRef",
        ref: textRef,
        class: Vue.normalizeClass(textKls.value),
        style: Vue.normalizeStyle({ "-webkit-line-clamp": __props.lineClamp })
      }, {
        default: Vue.withCtx(() => [Vue.renderSlot(_ctx.$slots, "default")]),
        _: 3
      }, 8, ["class", "style"]);
    };
  }
});
exports.default = text_vue_vue_type_script_setup_true_lang_default;
